//---------------------------------------------------------------------------

#include <vcl.h>
#include "Rs232.h"

//---------------------------------------------------------------------------
// ȫֶ
HANDLE          CommHandle;
DCB             CommDcb,OldDcb;
COMMTIMEOUTS    CommTimeout;


/*
*******************************************************************************
*                                                                             *
*                                RS232                                *
*                                                                             *
*******************************************************************************
*/

//---------------------------------------------------------------------------
void __fastcall     RS232Init(void)
{
    CommHandle = INVALID_HANDLE_VALUE;
}

//---------------------------------------------------------------------------
bool __fastcall RS232Open(AnsiString Port, int Baud)
{
    DWORD   count;
    unsigned char buf[256];

    CommHandle = CreateFile(Port.c_str(),GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,
                            FILE_ATTRIBUTE_NORMAL,NULL);
    if(CommHandle==INVALID_HANDLE_VALUE)                // ã9600bps
    {
        return false;
    }
    if(!GetCommState(CommHandle,&OldDcb))
    {
        CloseHandle(CommHandle);
        CommHandle = INVALID_HANDLE_VALUE;
        return false;
    }
    if(!SetupComm(CommHandle,16384,16384))
    {
        CloseHandle(CommHandle);
        CommHandle = INVALID_HANDLE_VALUE;
        return false;
    }
    CommTimeout.ReadIntervalTimeout = 0;
    CommTimeout.ReadTotalTimeoutMultiplier = 0;
    CommTimeout.ReadTotalTimeoutConstant = RS232TIMEBASE;
    CommTimeout.WriteTotalTimeoutMultiplier = 0;
    CommTimeout.WriteTotalTimeoutConstant = 0;
    if(!SetCommTimeouts(CommHandle,&CommTimeout))
    {
        CloseHandle(CommHandle);
        CommHandle = INVALID_HANDLE_VALUE;
        return false;
    }

    CommDcb.DCBlength = 28;
    CommDcb.BaudRate = Baud;
    CommDcb.fBinary = true;
    CommDcb.fParity = false;
    CommDcb.fOutxCtsFlow = false;
    CommDcb.fOutxDsrFlow = false;
    CommDcb.fDtrControl = DTR_CONTROL_DISABLE;
    CommDcb.fDsrSensitivity = false;
    CommDcb.fTXContinueOnXoff = false;
    CommDcb.fOutX = false;                       // ʹ÷
    CommDcb.fInX = false;
    CommDcb.fErrorChar = false;
    CommDcb.fNull = false;
    CommDcb.fRtsControl = RTS_CONTROL_DISABLE;//RTS_CONTROL_ENABLE;
    CommDcb.fAbortOnError = false;   // ʧܺǱclearcommerrorָܻͨ
    CommDcb.fDummy2 = 0x00;
//    CommDcb.wReserved = 0x00;
    CommDcb.XonLim = 1;
    CommDcb.XoffLim = 128;
    CommDcb.ByteSize = 8;
    CommDcb.Parity = NOPARITY;
    CommDcb.StopBits = ONESTOPBIT;
    CommDcb.XonChar = 0x1;          // start
    CommDcb.XoffChar = 0x13;        // stop
    CommDcb.ErrorChar = 0x02;
    CommDcb.EofChar = 0x03;
    CommDcb.EvtChar = 0x04;
    CommDcb.wReserved1 = 0x00;
    if(!SetCommState(CommHandle,&CommDcb))
    {
        CloseHandle(CommHandle);
        CommHandle = INVALID_HANDLE_VALUE;
        return false;
    }
    count = 1;
    while(count!=0)                                                 // 򿪴ʱֹ쳣ݽ
    {
        ReadFile(CommHandle,buf,256,&count,NULL);
    }
    return true;
}

//---------------------------------------------------------------------------
bool __fastcall RS232Baud(DWORD Baud)
{
    DWORD   oldbaud;

    if(CommHandle==INVALID_HANDLE_VALUE)
    {
        return false;
    }
    oldbaud = CommDcb.BaudRate;
    CommDcb.BaudRate = Baud;
    if(!SetCommState(CommHandle,&CommDcb))
    {
        CommDcb.BaudRate = oldbaud;
        SetCommState(CommHandle,&CommDcb);
        return false;
    }
    Sleep(2);															// ʱ2msȴģȶ
    return true;
}

//---------------------------------------------------------------------------
void __fastcall RS232Close(void)
{
    if(CommHandle==INVALID_HANDLE_VALUE)
    {
        return;
    }
    
    SetCommState(CommHandle,&OldDcb);
    CloseHandle(CommHandle);
    CommHandle = INVALID_HANDLE_VALUE;
}

//---------------------------------------------------------------------------
// ͻΪ֡LengthΪ֡ȣУֽڷʱԶ㣩
bool __fastcall RS232Send(unsigned char * pBuf, DWORD Length)
{
    DWORD   count;

    if(CommHandle==INVALID_HANDLE_VALUE)
    {
        return false;
    }

    *(pBuf+Length-1) = 0;               // Уֽڣֽڿʼ
    for(DWORD i=2;i<(Length-1);i++)
    {
        *(pBuf+Length-1) += *(pBuf+i);
    }

    WriteFile(CommHandle,pBuf,Length,&count,NULL);
    if(count!=Length)
    {
        return false;
    }
    
    return true;
}

//---------------------------------------------------------------------------
// ջΪ֡УֽڽպԶ飩
// 0ʾδյݻУʧܣ>0ʾѽݲУɹ
DWORD __fastcall RS232Recieve(unsigned char * pBuf, int FrameTime, int ByteTime)
{
    DWORD   length,count;
    int     time;
    unsigned char temp;
    
    if(CommHandle==INVALID_HANDLE_VALUE)
    {
        return 0;
    }

    FrameTime = (FrameTime+RS232TIMEBASE-1)/RS232TIMEBASE;
    if(FrameTime<1)
    {
        FrameTime = 1;
    }
    ByteTime = (ByteTime+RS232TIMEBASE-1)/RS232TIMEBASE;
    if(ByteTime<1)
    {
        ByteTime = 1;
    }
    
    length = 0;
    time = FrameTime;
    while(1)
    {
        while(1)
        {
            ReadFile(CommHandle,pBuf+length,1,&count,NULL);
            if(count==1)
            {
                break;
            }
            time -= 1;
            if(time<1)
            {
                return 0;
            }
        }
        
        time = ByteTime;               // յһֽںָΪֽڳʱ֡ʱ
        length += 1;
        if(length==1)
        {
            if(*pBuf!=UART_FLAG1)
            {
            	length = 0;
            	time = FrameTime;
            }
        }
        else if(length==2)
        {
            if(*(pBuf+1)!=UART_FLAG2)
            {
                length = 0;
            	time = FrameTime;
            }
        }
        else if(length==3)
        {
            if((*(pBuf+2)>UART_END)||(*(pBuf+2)<UART_BEGIN))
            {
                length = 0;
            	time = FrameTime;
            }
            temp = *(pBuf+2);
        }
        else
        {
            if(length>=DWORD(*(pBuf+3)+5))
            {
                if(temp==*(pBuf+length-1))
                {
                    break;
                }
                else
                {
                    length = 0;
            		time = FrameTime;
                }
            }
            else
            {
                temp += *(pBuf+length-1);
            }
        }
    }
    return DWORD(*(pBuf+3)+5);
}






